// H5 去调用App的方法
import jsBridge from "./bridge";
import { getUserInfo } from "@/api/user";

function saveUser(data) {
  localStorage.setItem("token", data);
  if (data) {
    getUserInfo().then(res => {
      console.log('存用户信息');
      console.log(res);
      console.log('----');
      if (res.code == 0) {
        localStorage.setItem("user", JSON.stringify(res.data));
      }
    })
  } else {
    console.log("调用失败");
  }
}

// 获取Token
export function getAuthToken() {
  const userAgent = navigator.userAgent;
  console.log("ua", userAgent);
  if (userAgent.indexOf('Android') > -1 || userAgent.indexOf('Adr') > -1) { // android
    console.log("android, 和安卓交互");
    const token = window.android.getAuthToken();
    console.log('an-token', token);
    return new Promise((resolve, reject) => {
      if (token) {
        saveUser(token);
        resolve(token)
      } else {
        reject('失败')
      }
    })
  } else if (userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) { // ios
    console.log("ios");
    return new Promise((resolve, reject) => {
      console.log("调用1");
      try {
        window.webkit.messageHandlers.Location.postMessage(null); //调用OC方法“postMessage”
        resolve('成功');
      } catch (e) {
        //TODO handle the exception
        reject('异常');
        console.log('ios, 异常');
      }
      //监听OC的方法
      // function setLocation(data) {
      //   console.log('监听', data);
      // }
      // jsBridge.callhandler("getAuthToken", null, data => {
      //   console.log("调用2");
      //   localStorage.setItem("token", data);
      //   console.log("--------------");
      //   if (data) {
      //     resolve(data)
      //     getUserInfo().then(res => {
      //       if (res.code === 0) {
      //         localStorage.setItem("user", JSON.stringify(res.data));
      //       }
      //     })
      //   } else {
      //     console.log("调用失败");
      //     reject("getAuthToken", data);
      //   }
      // });
    })
  }
}

// 退出
export function logoutToApp() {
  console.log("退出登录");
  jsBridge.callhandler("logout");
}
